<?php
/**
*
* @author Daniel CHALSECHE (Dakin Quelia) dakinquelia@hotmail.com
* @package phpBB3
* @version $Id: attachview.php, v0.0.1 2010/01/15 14:25:22 Dakin Quelia Exp $
* @copyright (c) 2008 http://www.danielchalseche.be
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
define('IN_PHPBB', true);
$phpbb_root_path = (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH : './../';
$phpEx = substr(strrchr(__FILE__, '.'), 1);
include($phpbb_root_path . 'common.' . $phpEx);

// Start session management
$user->session_begin();
$auth->acl($user->data);
$user->setup('mods/attachview');

page_header($user->lang['ATTACHVIEW'], false);

// Get some variables
$user_id = $user->data['user_id'];
$file	= request_var('file', 0);

// Check attachment is existing.
$sql = 'SELECT * FROM ' . ATTACHMENTS_TABLE . "
		WHERE attach_id = $file";
$result = $db->sql_query($sql);
$attach_id = (int) $db->sql_fetchfield('attach_id');
$db->sql_freeresult($result);

if (!$attach_id)
{
	trigger_error('NO_FILE');
}

// Get userlist
$sql = 'SELECT u.user_id, u.username, u.username_clean, u.user_type, u.user_colour, a.user_id, COUNT(a.user_id) AS nb, MAX(a.date) as date 
		FROM ' . USERS_TABLE . ' u, ' . ATTACHVIEW_TABLE . ' a
			WHERE u.user_id = a.user_id
				AND a.attach_id = ' . $file . '
			GROUP BY a.user_id
			ORDER BY u.username_clean';
$result = $db->sql_query($sql);

$prev_id = $prev_ip = $user_list = array();
$total = 0;

while ($row = $db->sql_fetchrow($result))
{
	// If user != anonymous
	if ($row['user_id'] != ANONYMOUS && !isset($prev_id[$row['user_id']]))
	{
		$user_colour = ($row['user_colour']) ? ' style="color:#' . $row['user_colour'] . '" class="username-coloured"' : '';
		$username_full = ($row['user_type'] != USER_IGNORE) ? get_username_string('full', $row['user_id'], $row['username'], $row['user_colour']) : '<span' . $user_colour . '>' . $row['username'] . '</span>';
		$dates = $user->format_date($row['date']);
			
		$prev_id[$row['user_id']] = 1;			
		$total++;
			
		// Send vars to template
		$template->assign_block_vars('user_row', array(
			'USERNAME_FULL'	=> $username_full,
			'DATES'			=> $dates,
			'NB'			=> $row['nb']
		));	
	}
}
	
$template->assign_vars(array(
	'TOTAL_DOWNLOADERS'	=> ($total == 1) ? sprintf($user->lang['AV_TOTAL_DOWNLOADER'], $total) : sprintf($user->lang['AV_TOTAL_DOWNLOADERS'], $total),
));
	
$db->sql_freeresult($result);
unset($prev_id, $prev_ip);

//What time is it ?
$now = time();
	
//Get total views and start time for this topic
$sql_infos = 'SELECT COUNT(attach_id) as total FROM ' . ATTACHVIEW_TABLE . '
				WHERE attach_id = ' . $file . '
				GROUP BY attach_id';
$result_infos = $db->sql_query($sql_infos);
$total_downloads = (int) $db->sql_fetchfield('total');
$db->sql_freeresult($result_infos);
	
$sql_infos = 'SELECT MIN(date) as date FROM ' . ATTACHVIEW_TABLE . '
				WHERE attach_id = ' . $file . '
				GROUP BY attach_id';
$result_infos = $db->sql_query($sql_infos);
$start_time = (int) $db->sql_fetchfield('date');
$db->sql_freeresult($result_infos);
			
if($total_downloads > 0)
{
	//Lets go...
	$current = $start_time;
		
	while($current < $now)
	{
		$next = mktime(0, 0, 0, intval(date("n", $current)) + 1, 1, intval(date("Y",$current)));
			
		$sql_nb = 'SELECT COUNT(date) as nb
					FROM ' . ATTACHVIEW_TABLE . '
					WHERE attach_id = ' . $file . '
						AND date >= ' . $current . ' AND date < ' . $next ;
		$result_nb = $db->sql_query($sql_nb);
		$nb	= (int) $db->sql_fetchfield('nb');
		$db->sql_freeresult($result_nb);
			
		// Send vars to template
		$template->assign_block_vars('stats', array(
			'MONTH'		=> $user->format_date($current, "F Y"),
			'PCT'		=> round($nb/$total_downloads*100),
			'PERCENT'	=> round($nb/$total_downloads*100,2) . '%',
			'RESULT'	=> $nb
		));	

		$current = $next;
	}
}

meta_refresh(60, append_sid("{$phpbb_root_path}download/attachview.$phpEx", "file=$file"));

$template->set_filenames(array(
	'body' => 'mods/attachview/attachview_body.html')
);

page_footer();

?>